# -*- coding: utf-8 -*-
############################################################################################################################################
#  HOJA DE DIFICULTADES:   Descripción
#  En este formulario se intentan recoger las dificultades que tiene cada alumno en el area linguistica 
#  Ademas se recoge las puntuaciones que recibirá¡ en caso de acierto y el maximo de puntos que deberá conseguir.
#

import wx
import codecs
import os

[wxID_BIT1] = [wx.NewId() for _init_ctrls in range(1)]

class Hoja_de_dificultades (wx.Frame):
    def __init__(self,padre,P,direccion,direccionAlumnos):        
        wx.Frame.__init__(self,id=wx.NewId(),name='',parent=padre,pos=wx.Point(100,120),size=wx.Size(500,400),style=wx.DEFAULT_FRAME_STYLE, title='Hoja de Dificultades')            
        
        self.direccionAlumnos=direccionAlumnos
        self.direccion=direccion
        self.P=P
        self.padre=padre
        
        try:
            # Recogemos todos los alumnos que tenemos registrados en el directorio alumnos
            listafich= os.listdir(self.direccionAlumnos)

        except:
            print "Error en la apertura de ficheros de Alumnos"
            
        # Introducimos en otra lista los ficheros que hemos encontrado pero codificado en utf8
        self.listadeficheros=[]
        for elemento in listafich: self.listadeficheros.append(elemento.decode('utf-8'))
        # Creamos una lista de alumnos sin la extensión del fichero, quedando solo el nombre del alumno.
        self.listadealumnos=[]
        for i in range(0,len(self.listadeficheros)):
            self.listadealumnos.append(self.listadeficheros[i][0:self.listadeficheros[i].find('.'):])
     
        # Creamos la ventana introduciendo los objetos

        self.comboalumno = wx.ComboBox(choices=self.listadealumnos, id=wx.NewId(),
              name='comboBox1', parent=self, pos=wx.Point(80, 12),
              size=wx.Size(165, 40), style=0, validator=wx.DefaultValidator,
              value='')
        self.Bind(wx.EVT_COMBOBOX,self.abrirfichero,self.comboalumno)
        self.confunde=wx.TextCtrl(id=wx.NewId(),name='nombreconfunde',parent=self,pos=wx.Point(100,70),size=wx.Size(50,40), style=wx.TE_PROCESS_ENTER,value='')
        self.puntmax=wx.TextCtrl(id=wx.NewId(),name='puntmax',parent=self,pos=wx.Point(400,55),size=wx.Size(50,30), style=wx.TE_PROCESS_ENTER,value=str(self.P.puntuacionmaxima))
        self.incremento=wx.TextCtrl(id=wx.NewId(),name='incremento',parent=self,pos=wx.Point(400,95),size=wx.Size(50,30), style=wx.TE_PROCESS_ENTER,value=str(self.P.incremento))
        self.lista= wx.ListBox (id=wx.NewId(),name='lista',parent=self,pos=wx.Point(20,120),size=wx.Size(100,200))      
        self.Texto0=wx.StaticText(self,-1,'Alumno:',(20,20),(50,40),wx.ALIGN_LEFT)      
        self.Texto1=wx.StaticText(self,-1,"Confunde:",(20,80),(50,40),wx.ALIGN_LEFT)
        self.Texto2=wx.StaticText(self,-1,"Puntuacion maxima: ",(250,60),(80,40),wx.ALIGN_LEFT)
        self.Texto3=wx.StaticText(self,-1,'Incremento por acierto: ',(250,100),(80,40),wx.ALIGN_LEFT)
        self.anadir=wx.Button ( id=wx.NewId(),label=u'Añadir',name="Anadir" , parent=self, pos=wx.Point(130,120),size=wx.Size(65,33),style=0)
        self.quitar=wx.Button ( id=wx.NewId(),label=u'Eliminar',name="Eliminar" , parent=self, pos=wx.Point(130,160),size=wx.Size(65,33),style=0)
        self.eliminaralumno=wx.Button ( id=wx.NewId(),label=u'Eliminar Alumno',name="Eliminaralumno" , parent=self, pos=wx.Point(230,200),size=wx.Size(145,50),style=0)
        self.guardar=wx.Button ( id=wx.NewId(),label=u'Guardar cambios',name="Guardar" , parent=self, pos=wx.Point(230,260),size=wx.Size(145,50),style=0)
        self.noguardarysalir=wx.Button ( id=wx.NewId(),label=u'Salir',name="Salir" , parent=self, pos=wx.Point(230,320),size=wx.Size(75,50),style=0)
        
        # Unimos los objetos a sus correspondientes subprocedimientos def
        self.Bind(wx.EVT_BUTTON,self.onanadir,self.anadir)
        self.Bind(wx.EVT_BUTTON,self.onquitar,self.quitar)
        self.Bind(wx.EVT_BUTTON,self.oneliminaralumno,self.eliminaralumno)
        self.Bind(wx.EVT_BUTTON,self.onguardar,self.guardar)
        self.Bind(wx.EVT_BUTTON,self.onsalirdeHD,self.noguardarysalir)
        self.Bind(wx.EVT_TEXT_ENTER,self.onanadir,self.confunde)
        self.Bind(wx.EVT_CLOSE,self.onsalirdeHD)
     
    
    def abrirfichero(self,event): # procedimiento para abrir un fichero de dificultades de cierto alumno
        
        try:# Recoge el nombre del alumno y su contraseña y guardalo en palabras
            for nombrearchivo in self.listadeficheros:
                if nombrearchivo[0:nombrearchivo.find('.'):]==self.comboalumno.GetValue():
                    self.P.nombrealumno=nombrearchivo[0:nombrearchivo.find('.'):]
                    self.P.contrasenaALUMNOstr=nombrearchivo[nombrearchivo.find('.')+1::]
                    break
            # abre el archivo
            archivo=codecs.open(self.direccionAlumnos+'/'+nombrearchivo,'r','utf-8')
            try:
                #lee todas las lineas del archivo que son tres 0-Dificultades 1- Puntuacion maxima 2- Incremento
                linea0= archivo.readline()
                linea0= linea0.replace("\n","")
                self.P.dificultades=linea0.split('-')
                self.lista.Clear()
                
                for elemento in self.P.dificultades:
                    self.lista.Append(elemento)
                    
                linea01= archivo.readline().replace('\n','')
                self.P.puntosletras=[float(n) for n in linea01.split('-')]
                
                linea02= archivo.readline().replace('\n','')
                self.P.fallosletras=[float(n) for n in linea02.split('-')]
                
                # saca los puntos por ejercicio y conviertelos en números enteros.
                linea03= archivo.readline().replace("\n","")
                lista03 =linea03.split('-')
                for i in range (0,len(lista03)):
                    self.P.puntosjuegos[i]=float (lista03[i])
                    
                # saca los fallos por ejercicio y conviertelos en números enteros.
                linea04= archivo.readline().replace("\n","")
                lista04=linea04.split('-')
                for i in range (0,len(lista04)):
                    self.P.fallosjuegos[i]=float(lista04[i])
                    
                
                linea1= archivo.readline()
                self.P.puntuacionmaxima= int(linea1.replace("\n",""))
                self.puntmax.SetValue(str(self.P.puntuacionmaxima))    
                linea2= archivo.readline()
                self.P.incremento= int(linea2.replace("\n",""))
                self.incremento.SetValue(str(self.P.incremento))
                archivo.close()
                
            except:
                m=wx.MessageBox ('Error leyendo archivo de dificultades','Info')
        except:
            m=wx.MessageBox ('No encontramos este usuario: /n Intentalo de nuevo','Info')
            
                
        event.Skip()

    def onanadir (self,event): #aÃ±ade dificultades a la lista
        #convierte en minusculas
        self.confunde.SetValue(self.confunde.GetValue().lower())
        # elimina los acentos, no utilizo P.sam puesto que quita la Ã±
        existeacento=False
        for elemento in u'áéíóúàèìòùäëïöüâêîôû':
            if elemento in self.confunde.GetValue():
                existeacento=True
                break
        # revisión para que no existan acentos en las silabas que introduce el tutor. No queremos que introduzca acentos
        # tampoco dejaremos que sea mayor de tres y tampoco dejaremos que repita dificultades
        if not existeacento and self.confunde.GetValue()!='' and len(self.confunde.GetValue())<3 and not self.confunde.GetValue() in self.P.dificultades:
            existe=False
            # revisa que cada dificultad que se quiera trabajar exista en los nombres de las f:"fotos guardadas de ARASAAC"
            try:
                listanombres= os.listdir(self.direccion+u"fotos") # Mira dentro de la carpeta de fotos de arasaac para ver si se pueden trabajar las dificultades
            except:
                m=wx.MessageBox ('No se encuentran los archivos de fotos' ,'Info')
            else:
                for elemento in listanombres:
                    if self.confunde.GetValue() in elemento: 
                        existe=True
                        break
                if existe: # si existe algun archivo con esa dificultad entonces añadirá el valor de la casilla confunde a a la lista.
                    self.lista.Append(self.confunde.GetValue())
                    self.P.dificultades.append(self.confunde.GetValue())
                    self.P.puntosletras.append(0)
                    self.P.fallosletras.append(0)
                    self.confunde.SetValue('')
            
        event.Skip()
        
    def onquitar (self,event):
        # elimina dificultades
        selections = list(self.lista.GetSelections())
        selections.reverse()
        for index in selections:
            self.lista.Delete(index) 
            self.P.dificultades.pop(index)
            self.P.fallosletras.pop(index)
            self.P.puntosletras.pop(index)
        event.Skip()
        
    def onguardar(self,event):
        # Guarda las dificultades, la puntuacion maxima de los 
        # ejercicios y también el incremento por ejercicio acertado.
        if len(self.P.dificultades)>4:
            if self.P.nombrealumno+'.'+self.P.contrasenaALUMNOstr in self.listadeficheros:
                try:
                    archivo=codecs.open(self.direccionAlumnos+'/'+self.P.nombrealumno+'.'+self.P.contrasenaALUMNOstr,'w','utf-8')
                    archivo.write('-'.join(self.P.dificultades)+'\n')                
                    lista=[str(n) for n in self.P.puntosletras]
                    archivo.write('-'.join(lista)+'\n')
                    lista=[str(n) for n in self.P.fallosletras]
                    archivo.write('-'.join(lista)+'\n')
                    lista=[str(n) for n in self.P.puntosjuegos]
                    archivo.write('-'.join(lista)+'\n')
                    lista=[str(n) for n in self.P.fallosjuegos]
                    archivo.write('-'.join(lista)+'\n')
                
                    
                    archivo.write(self.puntmax.GetValue()+'\n')
                    archivo.write(self.incremento.GetValue()+'\n')
                    self.P.puntuacionmaxima=int(self.puntmax.GetValue())
                    self.P.incremento=int(self.incremento.GetValue())
                    archivo.close ()
                    self.P.analizadificultades()
                except:
                    m=wx.MessageBox ('Error fatal.No pude escribir en #'+self.P.nombrealumno+'.' + self.P.contrasenaALUMNOstr + '#','Info')
            else:
                m=wx.MessageBox ('No se encuentra'+self.P.nombrealumno+'.'+self.P.contrasenaALUMNOstr ,'Info')
        else:
            m=wx.MessageBox ('Como mínimo tienes que introducir 5 letras en la lista de confusiones. No se ha guardado' ,'Info')
        event.Skip()
    
    def onsalirdeHD(self,event): # Sale completamente de la Hoja de dificultades
        if len(self.P.dificultades)<5:
            wx.MessageBox ('Como mínimo tienes que introducir 5 letras en la lista de confusiones. No se ha guardado' ,'Info')
        else:
            self.Hide()
            wx.Window.Enable(self.padre)
            self.P.analizadificultades()
            event.Skip()
        
    def oneliminaralumno(self,event):
        
        try:
            #buscando el nombre del archivo que corresponde en las listas de ficheros.
            for nombrearchivo in self.listadeficheros:
                if nombrearchivo[0:nombrearchivo.find('.'):]==self.comboalumno.GetValue():
                    self.P.nombrealumno=nombrearchivo[0:nombrearchivo.find('.'):]
                    self.P.contrasenaALUMNOstr=nombrearchivo[nombrearchivo.find('.')+1::]
                    break
            #borrando el nombre y el nombre del archivo de las listas
            self.listadeficheros.remove(nombrearchivo)
            self.listadealumnos.remove(self.comboalumno.GetValue())
            # borrar el archivo
            os.remove(self.direccionAlumnos+'/'+nombrearchivo)
            #inicializar y borrar los datos del formulario no validos
            self.comboalumno.Clear()
            self.lista.Clear()
            self.P.nombrealumno=""
            self.P.contrasenaALUMNOstr=""
            self.incremento.SetValue('0')
            self.puntmax.SetValue('0')
            for elemento in self.listadealumnos:
                self.comboalumno.Append(elemento)
            self.comboalumno.SetValue('')
        except:
            m=wx.MessageBox ('Algun error al borrar ','Info')
        event.Skip()

