#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de Pinchar en los dibujos que finalicen por la silaba descrita.
#
#

import wx
import codecs
import sys
import os
import random
import time


class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [30,1,u'Gontzal Uriarte',u'Acaba por...'] )
        self.tabla=[[1, '',''],[1, '',''],[1, '',''],[1, '',''],[1, '','']]
        self.solucion=""
        self.letra="a"
        self.silaba=""
        self.casoscorrectos=0
        self.casosacertados=0
        self.completada=False
        
    def Terminar3(self,event):
     
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        event.Skip()

    def Ayuda3     (self,event=None):        
        #ayudamos diciendo la siguiente sílaba
        self.sonido.habla('Pincha en los dibujos que terminen por la silaba del cuadro amarillo')
        self.Refresh()
        event.Skip()
        
        
    def Apoyo3(self,event=None):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<5 and not self.completada:            
            if self.tabla[int(x)][0]==1 :        
                self.sonido.habla(''.join(self.tabla[int(x)][1].split('-')))
        event.Skip()

    def PaintJuego3 (self,event):
     
        dc=wx.PaintDC(self)
        
        #escalar la imagenes y dibujarlas
        if not self.completada:
            for i in range(0,5):
                if self.tabla[i][0]==1:
                    img = wx.Image((self.direccion+"fotos//"+self.tabla[i][1]+".png"), wx.BITMAP_TYPE_ANY)
                    img= img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
                    img= wx.BitmapFromImage(img)
                    dc.DrawBitmap(img,20+i*150,70,False)
        else:
            for i in range(0,5):
                if self.tabla[i][0]==2:
                    img = wx.Image((self.direccion+"fotos//"+self.tabla[i][1]+".png"), wx.BITMAP_TYPE_ANY)
                    img= img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
                    img= wx.BitmapFromImage(img)
                    dc.DrawBitmap(img,200,70,False)
                    dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))    
                    dc.DrawText(self.tabla[i][1],420,90)
                    
        #dibujar los bloques con el texto
        dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))    
        img = wx.Image((self.direccion+"imagenes//bloqueamarillo.jpg"), wx.BITMAP_TYPE_ANY)
        img= img.Scale(180, 100, wx.IMAGE_QUALITY_HIGH)
        img= wx.BitmapFromImage(img)
        dc.DrawBitmap(img,400,300,True)
        dc.DrawText('Termina por:',50,320)
        dc.DrawText(self.P.maymin(self.silaba),445,320)
        event.Skip()
 
    def MotorJuego3(self,event):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<5 and not self.completada:            
            if self.tabla[int(x)][0]==1 :
                self.sonido.habla(''.join(self.tabla[int(x)][1].split('-')))
                silabas= self.tabla[int(x)][1].split('-')
                lultimasilaba = silabas[-1::]
                ultimasilaba= lultimasilaba[0]
                if self.silaba == ultimasilaba: 
                    self.completada=True
                    self.casosacertados+=1
                    self.tabla[int(x)][0]=2
                    self.P.puntos=self.P.puntos+(self.P.incremento)
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                    self.P.puntosjuegos[30]+=1
                    self.P.puntosletras[self.padre.num_letra(self.letra)]+=1
                else:
                    self.padre.sonido(1)
                    self.P.fallosjuegos[30]+=1
                    self.P.fallosletras[self.padre.num_letra(self.letra)]+=1
                if self.completada: 
                    time.sleep(1)
                    self.padre.sonido(22)
                    self.P.puntos+=self.P.incremento
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
        self.Refresh()
        event.Skip()
    
        
    def MainJuego3(self,event):
        self.inicializar()
        event.Skip()
    
    def Juego (self):
        self.SetBackgroundColour('Blue')
        self.padre.sonido(4)        
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar3 )
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego3)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda3)
        
        self.Bind(wx.EVT_PAINT, self.PaintJuego3)
        self.Bind (wx.EVT_LEFT_DOWN,self.MotorJuego3)  
        self.Bind(wx.EVT_RIGHT_DOWN,self.Apoyo3)
        self.inicializar()
        self.Show()
        
        
    def inicializar(self):
        
        # busca al menos dos palabras que empiezen por una letra de la tabla dificultades
        # Atencion si no encuentra ninguna la letra 'a' se toma por defecto.
        encontrado=False
        terminanconlaletra=[]
        
        while not encontrado:
            self.letra=random.choice(self.P.dificultades)
            for i in range(0,1000): 
                palabra= random.choice(self.P.tabla)
                silabas = palabra.split('-')
                lultimasilaba = silabas[-1::]
                ultimasilaba= lultimasilaba[0]
                if self.letra in ultimasilaba:
                    self.silaba=ultimasilaba
                    encontrado=True
                    terminanconlaletra.append(palabra)
                    break
        
        #introduciendo las palabras encontradas 
        for i in range(0,1):
            self.tabla[i][1]= random.choice(terminanconlaletra)
            self.tabla[i][2]=(self.P.samb(self.tabla[i][1]))
            self.tabla[i][0]= 1
        self.casosacertados=0
        self.casoscorrectos=2
        self.completada=False
        while self.casoscorrectos>1:
            self.casoscorrectos=0
            # introducimos algunas palabras al azar
            for i in range(1,5):
                self.tabla[i][1]= random.choice(self.P.tabla)
                self.tabla[i][2]=(self.P.samb(self.tabla[i][1]))
                self.tabla[i][0]= 1
            # mareamos la tabla para que no esten siempre en el mismo lado.
            random.shuffle(self.tabla)
            
            for i in range(0,5):
                palabra= self.tabla[i][1]
                silabas = palabra.split('-')
                lultimasilaba = silabas[-1::]
                ultimasilaba= lultimasilaba[0]
                if self.silaba == ultimasilaba:
                    self.casoscorrectos+=1 
        self.Refresh()
