#!/usr/bin/env python
# -*- coding: utf-8 -*-
# 28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
#   Este es el nucleo de todo el programa, la mesa de mandos de la nave Katamotz.
#   Contiene 3 clases   1[Palabras: Que contiene los datos linguisticos] 
#                       2[Hoja de Dificultades: Gestiona las dificultades del alumnos]
#                       3[Frame principal: Login y pantalla principal del menú]
#
# Trabajos que quedan por realizar:
#
#    2.- Cambios de contraseña. Por ahora hay que eliminar el alumno
#    3.- Activar o desactivar actividades en la ficha de dificultades
#    4.- Crear más frases.
#    
#    Ejercicios:
#    23.- Contar las palabras de una frase.
#    24.- Hacer un ahorcado (aparezca una cara 2ojos,2orejas,1nariz,2mofletes,boca,2cejas,pelo)con las palabras que el alumno precise.
#    26.- Completar una frase con palabras. La frase puede ser dictada oralmente.
#    27.- Buscar dos palabras iguales entre otras 8. (que se parezcan)
    
import wx   # necesario para activar los objetos de ventana,boton, dibujos...
import codecs # necesarios para abrir los archivos UTF8 sin problemas.
import sys # Para procedimientos de sistema interno
import os # Para procedimientos de sistema operativo
import random  # Para conseguir números aleatorios y mezclas aleatorias de palabras o letras.
import unicodedata # Para abrir archivos utf8 sin problemas
import glob # Para poder leer los archivos de un directorio con filtros (*.py) por ejemplo
#import talker # Modulo que hace posible escuchar la voz festival.
import sonido # Modulo que se encarga de la gestion de la voz festival.
from subprocess import Popen # para llamar un comando os
import PanelControl # contiene el panel que controla todas las actividades entrar salir y pregunta
import PanelContrasena  # contiene el panel que controla la entrada con contrasena
import PanelTipo # Panel de tipos de ejercicios
import PanelEjercicios # Panel de Ejercicios concretos
import FrameHojaDificultades # Frame de dificultades
import PanelEstadisticas

direccion= u"/usr/bin/katamotz-ejercicios/"
#direccion=u"/home/gontzal/Escritorio/katamotzejercicios/"
#direccion=u"/home/zior/Mahaigaina/katamotzejercicios/"
#direccion = u"C://Users//ZioR//Desktop//katamotzejercicios//"
#direccion=u"C://katamotzejercicios//"
    
# Aquí ponemos la direccion abosoluta del directorio de alumnos en Home
barra ="\\" if( os.name == "nt") else "//"
direccionAlumnos= os.path.expanduser("~")+ "//"+u'KatamotzAlumnos'
if not os.path.exists(direccionAlumnos):
    os.mkdir(direccionAlumnos)

#introduce dentro de las direcciones de busqueda de python la que nos compete (sin la / última)
sys.path.append (direccion[:-1:])
sys.path.append (direccion+'Juegos')

# cambia de directorio para buscar los modulos
os.chdir(direccion+'Juegos')

# busca los modulos
modulos=glob.glob("Juego*.py")
Juego=[]
# ordena los módulos
modulos.sort()
N_Ejercicios=len(modulos)


# Importando modulos
for i in range(0,N_Ejercicios):
    Juego.append(" ")
    Juego[i]= __import__(modulos[i].replace('.py','')) # elimina la extensión para importar 



if os.name=='posix':
    try:
        
        os.chdir(direccionAlumnos)
        os.system('lsb_release -d >version.txt')
        f2=open((direccionAlumnos + "//version.txt"),'r')
        version=f2.readline().split()
        f2.close()
        os.system('rm version.txt')
        version.pop(0)
    except:
        pass
    
        

##########################################################################################################################################
##########################################################################################################################################

# Palabras 
# Esta clase se encargará de manejar todo el materíal linguistico y fonológico del programa:
# Es decir será el almacen de Palabras, silabas, Frases, Textos....
# También será el contenedor de algunas subrutinas que modificarán estas palabras.

class Palabras:
    def __init__ (self):
        self.puntuacionmaxima=0
        self.incremento=0
        self.nombrealumno = ""
        self.contrasenaALUMNOstr = ""
        self.contrasenaMAESTRO=""
        self.puntos=0
        # Tabla contendrá el nombre de todos los archivos *.png del directorio foto con barra y acentos
        self.tabla= []
        # Tabla SAMB contendrá los mismos nombres de tabla pero Sin Acento Mayusculas y Barra
        self.tablaSAMB= []        
        # Tablas de silabas.
        self.silabas=['co','to','pu','me','te','lo']
        self.silabasD=[u'ña',u'ñe',u'ñi',u'ño',u'ñu',u'ba', u'be', u'bi', u'bo', u'bu', u'ca', u'ce', u'ci', u'co', u'cu', u'cha', u'che', u'chi', u'cho', u'chu', u'da', u'de', u'di', u'do', u'du', u'fa', u'fe', u'fi', u'fo', u'fu', u'ga', u'ge', u'gi', u'go', u'gu', u'ha', u'he', u'hi', u'ho', u'hu', u'ja', u'je', u'ji', u'jo', u'ju', u'la', u'le', u'li', u'lo', u'lu', u'lla', u'lle', u'lli', u'llo', u'llu', u'ma', u'me', u'mi', u'mo', u'mu', u'na', u'ne', u'ni', u'no', u'nu', u'pa', u'pe', u'pi', u'po', u'pu', u'que', u'qui', u'ra', u're', u'ri', u'ro', u'ru', u'sa', u'se', u'si', u'so', u'su', u'ta', u'te', u'ti', u'to', u'tu', u'va', u've', u'vi', u'vo', u'vu', u'za', u'ze', u'zi', u'zo', u'zu']
        self.silabasI=[u'ac', u'ec', u'ic', u'oc', u'uc', u'ad', u'ed', u'id', u'od', u'ud', u'af', u'ef', u'if', u'of', u'uf', u'al', u'el', u'il', u'ol', u'ul', u'am', u'em', u'im', u'om', u'um', u'an', u'en', u'in', u'on', u'un', u'ap', u'ep', u'ip', u'op', u'up', u'ar', u'er', u'ir', u'or', u'ur', u'as', u'es', u'is', u'os', u'us', u'az', u'ez', u'iz', u'oz', u'uz']
        self.silabasT=[u'bra', u'bre', u'bri', u'bro', u'bru', u'bla', u'ble', u'bli', u'blo', u'blu', u'fra', u'fre', u'fri', u'fro', u'fru', u'fla', u'fle', u'fli', u'flo', u'flu', u'cra', u'cre', u'cri', u'cro', u'cru', u'cla', u'cle', u'cli', u'clo', u'clu', u'dra', u'dre', u'dri', u'dro', u'dru', u'pra', u'pre', u'pri', u'pro', u'pru', u'pla', u'ple', u'pli', u'plo', u'plu', u'tra', u'tre', u'tri', u'tro', u'tru', u'gra', u'gre', u'gri', u'gro', u'gru', u'gla', u'gle', u'gli', u'glo', u'glu']
        self.silabasS=[u'bar', u'ber', u'bir', u'bor', u'bur', u'bal', u'bel', u'bil', u'bol', u'bul', u'bas', u'bes', u'bis', u'bos', u'bus', u'ban', u'ben', u'bin', u'bon', u'bun', u'bam', u'bem', u'bim', u'bom', u'bum', u'dar', u'der', u'dir', u'dor', u'dur', u'dal', u'del', u'dil', u'dol', u'dul', u'das', u'des', u'dis', u'dos', u'dus', u'dan', u'den', u'din', u'don', u'dun', u'dam', u'dem', u'dim', u'dom', u'dum', u'par', u'per', u'pir', u'por', u'pur', u'pal', u'pel', u'pil', u'pol', u'pul', u'pas', u'pes', u'pis', u'pos', u'pus', u'pan', u'pen', u'pin', u'pon', u'pun', u'pam', u'pem', u'pim', u'pom', u'pum', u'car', u'cer', u'cir', u'cor', u'cur', u'cal', u'cel', u'cil', u'col', u'cul', u'cas', u'ces', u'cis', u'cos', u'cus', u'can', u'cen', u'cin', u'con', u'cun', u'cam', u'cem', u'cim', u'com', u'cum', u'tar', u'ter', u'tir', u'tor', u'tur', u'tal', u'tel', u'til', u'tol', u'tul', u'tas', u'tes', u'tis', u'tos', u'tus', u'tan', u'ten', u'tin', u'ton', u'tun', u'tam', u'tem', u'tim', u'tom', u'tum', u'sar', u'ser', u'sir', u'sor', u'sur', u'sal', u'sel', u'sil', u'sol', u'sul', u'sas', u'ses', u'sis', u'sos', u'sus', u'san', u'sen', u'sin', u'son', u'sun', u'sam', u'sem', u'sim', u'som', u'sum', u'lar', u'ler', u'lir', u'lor', u'lur', u'las', u'les', u'lis', u'los', u'lus', u'lan', u'len', u'lin', u'lon', u'lun', u'lam', u'lem', u'lim', u'lom', u'lum', u'mar', u'mer', u'mir', u'mor', u'mur', u'mal', u'mel', u'mil', u'mol', u'mul', u'mas', u'mes', u'mis', u'mos', u'mus', u'man', u'men', u'min', u'mon', u'mun', u'nar', u'ner', u'nir', u'nor', u'nur', u'nal', u'nel', u'nil', u'nol', u'nul', u'nas', u'nes', u'nis', u'nos', u'nus', u'nan', u'nen', u'nin', u'non', u'nun', u'nam', u'nem', u'nim', u'nom', u'num', u'far', u'fer', u'fir', u'for', u'fur', u'fal', u'fel', u'fil', u'fol', u'ful', u'fas', u'fes', u'fis', u'fos', u'fus', u'fan', u'fen', u'fin', u'fon', u'fun', u'fam', u'fem', u'fim', u'fom', u'fum', u'jar', u'jer', u'jir', u'jor', u'jur', u'jal', u'jel', u'jil', u'jol', u'jul', u'jas', u'jes', u'jis', u'jos', u'jus', u'jan', u'jen', u'jin', u'jon', u'jun', u'jam', u'jem', u'jim', u'jom', u'jum', u'gar', u'ger', u'gir', u'gor', u'gur', u'gal', u'gel', u'gil', u'gol', u'gul', u'gas', u'ges', u'gis', u'gos', u'gus', u'gan', u'gen', u'gin', u'gon', u'gun', u'gam', u'gem', u'gim', u'gom', u'gum', u'zar', u'zer', u'zir', u'zor', u'zur', u'zal', u'zel', u'zil', u'zol', u'zul', u'zas', u'zes', u'zis', u'zos', u'zus', u'zan', u'zen', u'zin', u'zon', u'zun', u'zam', u'zem', u'zim', u'zom', u'zum']
        self.silabasTODAS=self.silabasI+self.silabasD+self.silabasT+self.silabasS
        
        # Estas son las letras que serán usadas en los ejercicios. Por defecto a
        self.letras=[u'a']
        # tabla de dificultades relacionada con letras
        self.dificultades=[]
        self.puntosletras=[]
        self.fallosletras=[]
        self.puntosjuegos=[]
        self.fallosjuegos=[]
        for i in range(0,N_Ejercicios):
            self.puntosjuegos.append(0)
            self.fallosjuegos.append(0)
        self.detallesjuego=[]
        self.Frases=[]
        self.Adivinanzas=[]
        self.Verdaderofalso=[]
        self.Sinonimos=[]
        self.Antonimos=[]
        self.Mayus=False
    def onminusculas(self,event=None): # Cambia a minúsculas
        self.Mayus=False
        
        
    def onmayusculas(self,event=None):  # Cambia a Mayusculas
        self.Mayus=True
    # Este subprocedimiento sera utilizado ampliamente por los juegos para que automaticamente se escriba
    # en mayusculas o minusculas dependiendo de la elección de menu.
    def maymin(self,palabra):   
        if self.Mayus:
            if type(palabra)!='unicode':
                return palabra.upper()
            else:
                return unicode(palabra,'utf-8').upper()
        else: #Como todo está en minusculas no hace falta convertir a minusculas y ademas respetamos las mayúsculas de inicio de las frases. 
            if type(palabra)!='unicode':
                return palabra
            else:
                return unicode(palabra,'utf-8')
             
        event.Skip()
        
    def sam (self,cadena):  #convierte una cadena sin acento sin ñ y en minúscula.
        def normaliza(c):
            return unicodedata.normalize("NFD",c)[0].lower()
        return ''.join(normaliza(c) for c in cadena)
    
    def samb (self,cadena): #convierte una cadena sin acento, sin ñ, minuscula y sin barra -
        return ''.join(self.sam(cadena).split('-'))
        
    

    def inicializatabla(self): # Carga todas las palabras de los archivos de imagenes de Arasaac de /fotos
        global direccion
        
        self.tabla= os.listdir(direccion+u"fotos")

        #quitar la extensión
        for i in range(0,len(self.tabla)):
            self.tabla[i]=self.tabla[i][0:self.tabla[i].find('.'):]          
        
        #abrir archivo de Frases
        abierto = False
        try:
            archivo = codecs.open(direccion+'Palabras//'+'Frases.txt','r','utf-8')
            
            abierto=True
        except:
            
            abierto=False
        self.Frases=[]
        if abierto:# Si ha sido posible abrir el archivo de Frases se introducirán en P.Frases
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()
                except:
                    Terminado=True
                    
                    
                if not estalinea: 
                    Terminado=True
                else:
                    self.Frases.append(estalinea)
        
        archivo.close()
        
        
        #abrir archivo de Adivinanzas.txt
        abierto = False
        try:
            archivo = codecs.open(direccion+'Palabras//'+'Adivinanzas.txt','r','utf-8')
            
            abierto=True
        except:
            
            abierto=False
        self.Adivinanzas=[]
        if abierto:# Si ha sido posible abrir el archivo de adivinanzas se rellenará el array self.adivinanzas
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()
                except:
                    Terminado=True
                    
                if not estalinea: 
                    Terminado=True
                else:
                    self.Adivinanzas.append(estalinea)
        
        archivo.close()
        
        
        #abrir archivo de Verdaderofalso.txt
        abierto = False
        try:
            archivo = codecs.open(direccion+'Palabras//'+'Verdaderofalso.txt','r','utf-8')
            
            abierto=True
        except:
            pass 
        # Abriendo archivo de Verdaderofalso.txt
        self.Verdaderofalso=[]
        if abierto:# Si ha sido posible abrir el archivo verdadero falso se introduciran las frases
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()
                 
                except:
                    Terminado=True
                    
                    
                if not estalinea: 
                    Terminado=True
                else:
                    self.Verdaderofalso.append(estalinea)
        
        archivo.close()
        

#abrir archivo de Sinonimos.txt
        abierto = False
        try:
            archivo = codecs.open(direccion+'Palabras//'+'Sinonimos.txt','r','utf-8')
            
            abierto=True
        except:
            pass
        # Abriendo archivo de Sinonimos.txt
        self.Sinonimos=[]
        if abierto:# Si ha sido posible abrir el archivo verdadero falso se introduciran las frases
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()
                 
                except:
                    Terminado=True
                    
                    
                if not estalinea: 
                    Terminado=True
                else:
                    self.Sinonimos.append(estalinea)
        
        archivo.close()
        
#abrir archivo de Antonimos.txt
        abierto = False
        try:
            archivo = codecs.open(direccion+'Palabras//'+'Antonimos.txt','r','utf-8')
            
            abierto=True
        except:
            pass
        # Abriendo archivo de Sinonimos.txt
        self.Antonimos=[]
        if abierto:# Si ha sido posible abrir el archivo verdadero falso se introduciran las frases
            Terminado=False
            while not Terminado:
                try:
                    estalinea = archivo.readline()         
                except:
                    Terminado=True
                    
                    
                if not estalinea: 
                    Terminado=True
                else:
                    self.Antonimos.append(estalinea)
        
        archivo.close()




    def analizadificultades(self):  # Analizar las dificultades es introducir las dificultades en P.letras
        for elemento in self.dificultades:
            self.letras.append(elemento)
             
        
class KatamotzPrincipal(wx.Frame):
    def __init__(self, parent, title):
        super(KatamotzPrincipal, self).__init__(parent, title=title)
        global P,direccion,direccionAlumnos,N_Ejercicios,S,Juego
        self.P=P
        self.S=S
        self.Juego=Juego
        self.N_Ejercicios = N_Ejercicios
        self.direccion=direccion
        self.direccionAlumnos=direccionAlumnos
        self.pantalla=0        
        # 0:Tipo 1:P_Ejercicios 2:Juego en
        P.inicializatabla()
        self.SetSize((1100,650))
        
        self.Tabla_Ejercicios=[]
        self.muestra=[]
        for i in range(0,self.N_Ejercicios):
            self.muestra.append(Juego[i].ModuloJuego(self,self.P,self.S,self.direccion))
            self.muestra[i].Hide()
        

        # Barra de menu
        self.frame_1_menubar = wx.MenuBar()
        self.opciones = wx.Menu()
        self.modolectura = wx.Menu()
        self.Herram=wx.Menu()
        self.ayuda = wx.Menu()

        
        self.mayusculas = wx.MenuItem(self.modolectura, 111, u"Mayúsculas", "", wx.ITEM_NORMAL)
        self.modolectura.AppendItem(self.mayusculas)
        self.minusculas = wx.MenuItem(self.modolectura, 112, u"Minúsculas", "", wx.ITEM_NORMAL)
        self.modolectura.AppendItem(self.minusculas)
        self.opciones.AppendMenu(113, u"Tipo letra", self.modolectura, "")
        self.frame_1_menubar.Append(self.opciones, u"Opciones") # Opciones
        
        self.Herramientas = wx.MenuItem(self.Herram, 114,u"Configuración pedagógica","",wx.ITEM_NORMAL)
        self.Herram.AppendItem(self.Herramientas)
        self.Herramientas2 = wx.MenuItem(self.Herram, 115,u"Cambio de usuario","",wx.ITEM_NORMAL)
        self.Herram.AppendItem(self.Herramientas2)
        self.frame_1_menubar.Append(self.Herram, u"Herramientas") # Herramientas
        
        self.sobrekatamotz= wx.MenuItem(self.ayuda, 116, u"Sobre Katamotz Juego", "", wx.ITEM_NORMAL)
        self.ayuda.AppendItem(self.sobrekatamotz)
        self.frame_1_menubar.Append(self.ayuda, u"Ayuda") #Ayuda

        self.SetMenuBar(self.frame_1_menubar)
        
        # Finalizada la barra de menu y escondela
        self.frame_1_menubar.EnableTop(0, False);self.frame_1_menubar.EnableTop(1, False);self.frame_1_menubar.EnableTop(2, False)


        # Unión del Menu con sus procesos
        wx.EVT_MENU(self, 114,self.ondificultades)
        wx.EVT_MENU( self,115,self.oncambiausuario)# Cambio de usuario
        wx.EVT_MENU(self,116, self.onsobrekatamotz)
        self.Bind(wx.EVT_MENU, self.P.onmayusculas,self.mayusculas)
        self.Bind(wx.EVT_MENU, self.P.onminusculas,self.minusculas)
        self.Bind(wx.EVT_CLOSE,self.onclose)

        
        self.Panel_tipo= PanelTipo.Tiposdeejercicios(self,self.P,self.direccion,self.direccionAlumnos,self.N_Ejercicios, self.Juego)
        self.Panel_tipo.Hide()
        self.Herra= FrameHojaDificultades.Hoja_de_dificultades (self,self.P,direccion,direccionAlumnos)
        self.Herra.Hide()
        self.SetBackgroundColour('Blue')
        self.SetDoubleBuffered(True)
        # muestra el panel de contraseña
        self.Panel_contrasena= PanelContrasena.Contrasena(self,self.P,direccion,direccionAlumnos)
        self.Panel_contrasena.Show()
        
        
    def ondificultades(self,event=None): #Evento de menu
        self.Herra.Show()
        wx.Window.Disable(self)
        
        
    def onsobrekatamotz(self,event=None):
        m= wx.MessageBox (u'Katamotz ejercicios es un conjunto de actividades y juegos encaminados a mejorar el proceso de lectura y escritura de los alumnos. Especialmente recomendado a alumnos con dislexia.\n\nCreador: Gonzalo Uriarte Gómez. \nContacto: txasatonga@yahoo.es. \n\nKatamotz Ejercicios 0.34 (CopyRight) 2011 GNU/GPL versión 3.\nUsted puede modificar, copiar y distribuir este software libremente manteniendo mi autoría.','Katamotz Ejercicios')
        
        
   
    def oncambiausuario(self,event=None):
        self.frame_1_menubar.EnableTop(0, False);self.frame_1_menubar.EnableTop(1, False);self.frame_1_menubar.EnableTop(2, False)
        self.Panel_contrasena.Show() 
        self.guarda_estadisticas()
        self.P.puntos=0
        self.Panel_tipo.Hide()
        
    
        
        
    def num_letra(self,letra):
        for i in range (0,len(self.P.dificultades)):
            if self.P.dificultades[i]==letra:
                return i
                break
            
    def guarda_estadisticas(self):
        # controlar que el alumno no exista anteriormente.
        fcoinciden= glob.glob(self.direccionAlumnos+'//'+P.nombrealumno.lower()+'.*')
        if len(fcoinciden)!=0:
            archivo=codecs.open(self.direccionAlumnos+'//'+P.nombrealumno.lower()+'.'+self.P.contrasenaALUMNOstr,'w','utf-8')
            archivo.write('-'.join(P.dificultades)+'\n')
            lista=[str(n) for n in self.P.puntosletras]
            archivo.write('-'.join(lista)+'\n')
            lista=[str(n) for n in self.P.fallosletras]
            archivo.write('-'.join(lista)+'\n')
            lista=[str(n) for n in self.P.puntosjuegos]
            archivo.write('-'.join(lista)+'\n')
            lista=[str(n) for n in self.P.fallosjuegos]
            archivo.write('-'.join(lista)+'\n')
            
            archivo.write(str(P.puntuacionmaxima)+'\n')
            archivo.write(str(P.incremento)+'\n')
            archivo.close ()    
        
        
        
    def onclose(self,event=None):#Evento para cerraar
        
        if self.pantalla==0: # Si esta en la pantalla de contraseña o de Ejercicios_Tipo
            self.guarda_estadisticas()
            try:
                self.tiempo.Destroy()
            except:
                pass
            S.Cerrar()
            self.Destroy()
            
        elif self.pantalla==1: # Si esta en la pantalla de ejercicios pasa a la pantalla de Ejercicios_tipo.
            self.pantalla=0
            self.Panel_ejercicios.Destroy()
            self.Panel_control.Hide()
            self.Panel_tipo.Show()
            self.guarda_estadisticas()
            self.SetTitle('Katamotz Ejercicios')
            self.frame_1_menubar.EnableTop(1, True)
            
            try:
                self.tiempo.Destroy()
            except:
                pass
        

    def sonido(self,numero):
        S.sonido(numero)
                    

    def configurapantalla(self):
        self.P.analizadificultades()
        self.Panel_contrasena.Hide()
        self.Panel_tipo.Show()
        self.frame_1_menubar.EnableTop(0, True);self.frame_1_menubar.EnableTop(1, True);self.frame_1_menubar.EnableTop(2, True)
        self.pantalla=0 #1:pantalla Tipo
        
        
P= Palabras()
# La clase "Sonido" gestiona los sonidos que esta en el modulo sonido, le paso la direccion absoluta de los archivos
if os.name=='nt':
    S= sonido.SonidoWin(direccion)
elif os.name=='posix':
    if float(version[1])> 10 : 
        S= sonido.SonidoSoket(direccion)
    elif float(version[1])< 10 : 
        S= sonido.SonidoEspect(direccion)



class TestApp(wx.App):
    def OnInit(self):
        self.frame = KatamotzPrincipal(None, "Katamotz Ejercicios")
        self.SetTopWindow(self.frame)
        self.frame.Show(True)
        S.Run()
        S.Abrir()
        return True


if __name__ == "__main__":
    app=TestApp()
    app.MainLoop()     
     
