#!/usr/bin/env python
# -*- coding: utf-8 -*-
# 
import time
import subprocess 
import os

    
if os.name=='posix':
    import talker
    H=talker.Talker()
    from ossaudiodev import open as ossOpen
    from wave import open as waveOpen
    
elif os.name=="nt":
    import winsound
    import win32com.client
    
class SonidoEspect():
    def __init__ (self,direccion):
        self.direccion=direccion    
    def habla(self,frase):
        H.Say(frase+',')
        
    def sonido(self,numero):
        if numero==1:
            archivo=self.direccion+ 'sonidos//' + 'boing.wav' # mal
        elif numero==2: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==20: 
            archivo=self.direccion+'sonidos//'+'31883__HardPCM__Chip046.wav'
        elif numero==21:
            archivo=self.direccion+'sonidos//'+'17633__flatfly__pman8.wav'
        elif numero==22:
            archivo=self.direccion+'sonidos//'+'riendo.wav'
        elif numero==3: 
            archivo=self.direccion+'sonidos//'+'110931__chrisw92__error2.wav'
        elif numero==30:
            archivo=self.direccion+'sonidos//'+'cristales.wav'
        elif numero==4: 
            archivo=self.direccion+'sonidos//'+'entrando1.wav'
        elif numero==5: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==6: 
            archivo=self.direccion+'sonidos//'+'61234__sapht__SNES_startup.wav'
        

        try:
            file_name = archivo
            s = waveOpen(file_name,'rb')
            (nc,sw,fr,nf,comptype, compname) = s.getparams( )
            dsp = ossOpen('/dev/dsp','w')
            try:
                from ossaudiodev import AFMT_S16_NE
            except ImportError:
                if byteorder == "little":
                    AFMT_S16_NE = ossaudiodev.AFMT_S16_LE
                else:
                    AFMT_S16_NE = ossaudiodev.AFMT_S16_BE
            dsp.setparameters(AFMT_S16_NE, nc, fr)
            data = s.readframes(nf)
            s.close()
            dsp.write(data)
            dsp.close()
        except:
            pass

        
        
    def Cerrar(self):
        try:
            H.Close()  
            H.Kill()
        except:
            pass
        
    def Abrir( self):        
        H.Open()
        
    def Run(self): 
        pass





class SonidoSoket():
    def __init__ (self,direccion):
        self.direccion=direccion
        self.p=""
    def habla(self,frase):        
        p1 = subprocess.Popen([u"echo", frase], stdout=subprocess.PIPE)
        p2 = subprocess.Popen([u"iconv", '-f','utf-8','-t','iso-8859-1'],stdin=p1.stdout,stdout=subprocess.PIPE)
        p3 = subprocess.Popen([u"festival", u"--tts"], stdin=p2.stdout, stdout=subprocess.PIPE)

        
    def sonido(self,numero):
        if numero==1:
            archivo=self.direccion+ 'sonidos//' + 'boing.wav'
        elif numero==2: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==20: 
            archivo=self.direccion+'sonidos//'+'31883__HardPCM__Chip046.wav'
        elif numero==21:
            archivo=self.direccion+'sonidos//'+'17633__flatfly__pman8.wav'
        elif numero==22:
            archivo=self.direccion+'sonidos//'+'riendo.wav'
        elif numero==3: 
            archivo=self.direccion+'sonidos//'+'110931__chrisw92__error2.wav'
        elif numero==30:
            archivo=self.direccion+'sonidos//'+'cristales.wav'
        elif numero==4: 
            archivo=self.direccion+'sonidos//'+'entrando1.wav'
        elif numero==5: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==6: 
            archivo=self.direccion+'sonidos//'+'61234__sapht__SNES_startup.wav'
        
        self.playing = subprocess.Popen (['aplay',archivo])    
        
        
    def Cerrar(self):
        pass
        
    def Abrir(self):
        pass
        
    def Run(self):
        pass





class SonidoWin():
    def __init__ (self,direccion):
        self.direccion=direccion
        self.engine=""
    def habla(self,frase):
        try:
            frase.encode('utf8').decode('latin-1')
            self.speaker.Speak(frase)
        except:
            pass
        
    def sonido(self,numero):
        if numero==1:
            archivo=self.direccion+ 'sonidos//' + 'boing.wav'
        elif numero==2: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==20: 
            archivo=self.direccion+'sonidos//'+'31883__HardPCM__Chip046.wav'
        elif numero==21:
            archivo=self.direccion+'sonidos//'+'17633__flatfly__pman8.wav'
        elif numero==22:
            archivo=self.direccion+'sonidos//'+'riendo.wav'
        elif numero==3: 
            archivo=self.direccion+'sonidos//'+'110931__chrisw92__error2.wav'
        elif numero==30:
            archivo=self.direccion+'sonidos//'+'cristales.wav'
        elif numero==4: 
            archivo=self.direccion+'sonidos//'+'entrando1.wav'
        elif numero==5: 
            archivo=self.direccion+'sonidos//'+'botella.wav'
        elif numero==6: 
            archivo=self.direccion+'sonidos//'+'61234__sapht__SNES_startup.wav'
        
        winsound.PlaySound(archivo, winsound.SND_FILENAME)
        
    def Cerrar(self):
        pass
    def Abrir(self):
        pass
        
    def Run(self): 
        self.speaker = win32com.client.Dispatch("SAPI.SpVoice")
        voicelist = self.speaker.GetVoices()
        names=[]
        for i in range(voicelist.Count):
            item = voicelist.Item(i)
            name = item.GetAttribute('Name')
            names.append(name)
            if "Isabel" in names[i]:
                voicename = names[i]
                voicelist = self.speaker.GetVoices()
                for i in range(voicelist.Count):
                    item = voicelist.Item(i)
                    name = item.GetAttribute('Name')
                    if (name == voicename):
                        self.speaker.Voice = item
                        self.speaker.Rate= -2

        
        
        


